using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace EnterpriseDesktop.Controls
{
    public partial class Contacts : UserControl
    {
        public Contacts()
        {
            InitializeComponent();
            this.Dock = DockStyle.Fill;
        }

        private void contactBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.contactBindingSource.EndEdit();
            this.contactTableAdapter.Update(this.contactDataSet.Contact);

        }

        private void Contacts_Load(object sender, EventArgs e)
        {
            // Go and get the contacts
            this.contactDataSet.Merge(contactTableAdapter.GetData());

            // Update Title Drop Down
            UpdateTitleComboBox();
        }

        private void UpdateTitleComboBox()
        {
            _cmbxTitle.Items.Add(String.Empty); // give us a blank one to start with
            foreach (ContactDataSet.ContactRow row in this.contactDataSet.Contact.Rows)
            {
                if (row.IsTitleNull())
                {
                    continue;
                }
                if (_cmbxTitle.Items.Contains(row.Title) == false)
                {
                    _cmbxTitle.Items.Add(row.Title);
                }
            }
        }
        private void _txtFirstName_TextChanged(object sender, EventArgs e)
        {
            Filter();
        }

        private void Filter()
        {
            string filter = String.Empty;
            string connector = " AND ";

            if (!String.IsNullOrEmpty(_txtFirstName.Text))
            {
                filter = "FirstName LIKE '%" + _txtFirstName.Text.Replace("'", "''") + "%'" + connector;
            }
            if (!String.IsNullOrEmpty(_txtLastName.Text))
            {
                filter += "LastName LIKE '%" + _txtLastName.Text.Replace("'", "''") + "%'" + connector;
            }
            if (!String.IsNullOrEmpty(_cmbxTitle.Text))
            {
                filter += "Title='" + _cmbxTitle.Text + "'" + connector;
            }
            if (filter.Length > 0)
            {
                contactBindingSource.Filter = filter.Substring(0, filter.Length - 5);
            }
            else
            {
                contactBindingSource.Filter = String.Empty;
            }
                       
        }

        private void _txtLastName_TextChanged(object sender, EventArgs e)
        {
            Filter();
        }

        private void _cmbxTitle_SelectedIndexChanged(object sender, EventArgs e)
        {
            Filter();
        }
    }
}
